using System;
using Microsoft.EntityFrameworkCore.Migrations;

#nullable disable

namespace Watcher.Migrations
{
    /// <inheritdoc />
    public partial class InitialMigration : Migration
    {
        /// <inheritdoc />
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "ContainerMetrics",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Timestamp = table.Column<DateTime>(type: "TEXT", nullable: false),
                    ContainerId = table.Column<int>(type: "INTEGER", nullable: true),
                    CPU_Load = table.Column<double>(type: "REAL", nullable: false),
                    CPU_Temp = table.Column<double>(type: "REAL", nullable: false),
                    RAM_Size = table.Column<double>(type: "REAL", nullable: false),
                    RAM_Load = table.Column<double>(type: "REAL", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_ContainerMetrics", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Images",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Name = table.Column<string>(type: "TEXT", nullable: true),
                    Tag = table.Column<string>(type: "TEXT", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Images", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Metrics",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Timestamp = table.Column<DateTime>(type: "TEXT", nullable: false),
                    ServerId = table.Column<int>(type: "INTEGER", nullable: true),
                    CPU_Load = table.Column<double>(type: "REAL", nullable: false),
                    CPU_Temp = table.Column<double>(type: "REAL", nullable: false),
                    GPU_Load = table.Column<double>(type: "REAL", nullable: false),
                    GPU_Temp = table.Column<double>(type: "REAL", nullable: false),
                    GPU_Vram_Size = table.Column<double>(type: "REAL", nullable: false),
                    GPU_Vram_Usage = table.Column<double>(type: "REAL", nullable: false),
                    RAM_Size = table.Column<double>(type: "REAL", nullable: false),
                    RAM_Load = table.Column<double>(type: "REAL", nullable: false),
                    DISK_Size = table.Column<double>(type: "REAL", nullable: false),
                    DISK_Usage = table.Column<double>(type: "REAL", nullable: false),
                    DISK_Temp = table.Column<double>(type: "REAL", nullable: false),
                    NET_In = table.Column<double>(type: "REAL", nullable: false),
                    NET_Out = table.Column<double>(type: "REAL", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Metrics", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Tags",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Name = table.Column<string>(type: "TEXT", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Tags", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Users",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Username = table.Column<string>(type: "TEXT", maxLength: 50, nullable: false),
                    Email = table.Column<string>(type: "TEXT", nullable: true),
                    LastLogin = table.Column<DateTime>(type: "TEXT", nullable: false),
                    Password = table.Column<string>(type: "TEXT", nullable: false)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Users", x => x.Id);
                });

            migrationBuilder.CreateTable(
                name: "Containers",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    ServerId = table.Column<int>(type: "INTEGER", nullable: false),
                    ContainerId = table.Column<string>(type: "TEXT", nullable: true),
                    Image = table.Column<string>(type: "TEXT", nullable: true),
                    Name = table.Column<string>(type: "TEXT", nullable: true),
                    IsRunning = table.Column<bool>(type: "INTEGER", nullable: false),
                    ImageId = table.Column<int>(type: "INTEGER", nullable: true),
                    TagId = table.Column<int>(type: "INTEGER", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Containers", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Containers_Images_ImageId",
                        column: x => x.ImageId,
                        principalTable: "Images",
                        principalColumn: "Id");
                    table.ForeignKey(
                        name: "FK_Containers_Tags_TagId",
                        column: x => x.TagId,
                        principalTable: "Tags",
                        principalColumn: "Id");
                });

            migrationBuilder.CreateTable(
                name: "Servers",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Name = table.Column<string>(type: "TEXT", nullable: false),
                    IPAddress = table.Column<string>(type: "TEXT", nullable: false),
                    Type = table.Column<string>(type: "TEXT", nullable: false),
                    Description = table.Column<string>(type: "TEXT", nullable: true),
                    CpuType = table.Column<string>(type: "TEXT", nullable: true),
                    CpuCores = table.Column<int>(type: "INTEGER", nullable: false),
                    GpuType = table.Column<string>(type: "TEXT", nullable: true),
                    RamSize = table.Column<double>(type: "REAL", nullable: false),
                    DiskSpace = table.Column<string>(type: "TEXT", nullable: true),
                    CPU_Load_Warning = table.Column<double>(type: "REAL", nullable: false),
                    CPU_Load_Critical = table.Column<double>(type: "REAL", nullable: false),
                    CPU_Temp_Warning = table.Column<double>(type: "REAL", nullable: false),
                    CPU_Temp_Critical = table.Column<double>(type: "REAL", nullable: false),
                    RAM_Load_Warning = table.Column<double>(type: "REAL", nullable: false),
                    RAM_Load_Critical = table.Column<double>(type: "REAL", nullable: false),
                    GPU_Load_Warning = table.Column<double>(type: "REAL", nullable: false),
                    GPU_Load_Critical = table.Column<double>(type: "REAL", nullable: false),
                    GPU_Temp_Warning = table.Column<double>(type: "REAL", nullable: false),
                    GPU_Temp_Critical = table.Column<double>(type: "REAL", nullable: false),
                    Disk_Usage_Warning = table.Column<double>(type: "REAL", nullable: false),
                    Disk_Usage_Critical = table.Column<double>(type: "REAL", nullable: false),
                    DISK_Temp_Warning = table.Column<double>(type: "REAL", nullable: false),
                    DISK_Temp_Critical = table.Column<double>(type: "REAL", nullable: false),
                    CreatedAt = table.Column<DateTime>(type: "TEXT", nullable: false),
                    IsOnline = table.Column<bool>(type: "INTEGER", nullable: false),
                    LastSeen = table.Column<DateTime>(type: "TEXT", nullable: false),
                    IsVerified = table.Column<bool>(type: "INTEGER", nullable: false),
                    TagId = table.Column<int>(type: "INTEGER", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_Servers", x => x.Id);
                    table.ForeignKey(
                        name: "FK_Servers_Tags_TagId",
                        column: x => x.TagId,
                        principalTable: "Tags",
                        principalColumn: "Id");
                });

            migrationBuilder.CreateTable(
                name: "LogEvents",
                columns: table => new
                {
                    Id = table.Column<int>(type: "INTEGER", nullable: false)
                        .Annotation("Sqlite:Autoincrement", true),
                    Timestamp = table.Column<DateTime>(type: "TEXT", nullable: false),
                    Message = table.Column<string>(type: "TEXT", nullable: true),
                    Level = table.Column<string>(type: "TEXT", nullable: true),
                    ServerId = table.Column<int>(type: "INTEGER", nullable: true),
                    ContainerId = table.Column<int>(type: "INTEGER", nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_LogEvents", x => x.Id);
                    table.ForeignKey(
                        name: "FK_LogEvents_Containers_ContainerId",
                        column: x => x.ContainerId,
                        principalTable: "Containers",
                        principalColumn: "Id");
                    table.ForeignKey(
                        name: "FK_LogEvents_Servers_ServerId",
                        column: x => x.ServerId,
                        principalTable: "Servers",
                        principalColumn: "Id");
                });

            migrationBuilder.CreateIndex(
                name: "IX_Containers_ImageId",
                table: "Containers",
                column: "ImageId");

            migrationBuilder.CreateIndex(
                name: "IX_Containers_TagId",
                table: "Containers",
                column: "TagId");

            migrationBuilder.CreateIndex(
                name: "IX_LogEvents_ContainerId",
                table: "LogEvents",
                column: "ContainerId");

            migrationBuilder.CreateIndex(
                name: "IX_LogEvents_ServerId",
                table: "LogEvents",
                column: "ServerId");

            migrationBuilder.CreateIndex(
                name: "IX_Servers_TagId",
                table: "Servers",
                column: "TagId");
        }

        /// <inheritdoc />
        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropTable(
                name: "ContainerMetrics");

            migrationBuilder.DropTable(
                name: "LogEvents");

            migrationBuilder.DropTable(
                name: "Metrics");

            migrationBuilder.DropTable(
                name: "Users");

            migrationBuilder.DropTable(
                name: "Containers");

            migrationBuilder.DropTable(
                name: "Servers");

            migrationBuilder.DropTable(
                name: "Images");

            migrationBuilder.DropTable(
                name: "Tags");
        }
    }
}
